package cn.leo.nio.processer;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;

import cn.leo.nio.service.ServiceListener;

public class Reader implements Runnable {
	private static final int INT_LENGTH = 4;

	private SelectionKey key;
	private ServiceListener mListener;

	public Reader(SelectionKey key, ServiceListener mListener) {
		super();
		this.key = key;
		this.mListener = mListener;
	}

	@Override
	public void run() {
		Thread.currentThread().setName("Thread-Reader");
		SocketChannel sc = (SocketChannel) key.channel(); // ȡkeyƵ
		ByteBuffer headBuffer = ByteBuffer.allocate(INT_LENGTH); // 1intֵͷֽڴ洢ݳ
		ByteBuffer buf = (ByteBuffer) key.attachment(); // ȡkeyĸӶΪӵĻ
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		try {
			while (sc.read(headBuffer) == INT_LENGTH) {
				int dataLength = headBuffer.getInt(0); // ȡͷ4ֽڵintֵݳ
				headBuffer.clear();
				byte[] bytes;
				int receiveLength = 0; // ѽܳ
				int bytesRead = 0;// ȡƵڵݵ
				while (receiveLength < dataLength) {
					if (dataLength - receiveLength < buf.capacity()) { // һֱȻСС
						buf.limit(dataLength - receiveLength);
					}
					bytesRead = sc.read(buf); // TODO BUGҪ
					buf.flip();// ûlimit

					if (bytesRead < 1) { // ȡ˳
						break;
					}

					if (receiveLength + bytesRead > dataLength) { // ܵݴָ
						bytes = new byte[dataLength - receiveLength]; // µΪʣݳ
					} else {
						bytes = new byte[bytesRead]; // Ϊȡ
					}
					buf.get(bytes);
					baos.write(bytes);
					buf.clear();// ջ
					receiveLength += bytes.length; // Ѷȡݳ
				}
				if (mListener != null) {
					mListener.onDataArrived(key, baos.toByteArray());
				}
				baos.reset();
				if (bytesRead == -1) { // ϿӣرƵ
					sc.close();
				}
			}
			ReaderManager.remove(key);
		} catch (IOException e) {
			try {
				sc.close();
			} catch (IOException e1) {
				// e1.printStackTrace();
			}
			if (mListener != null) {
				mListener.onConnectInterrupt(key);
			}
		}
	}

}
