package cn.leo.nio.processer;

import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;

import cn.leo.nio.service.ServiceListener;

public class Writer implements Runnable {
	private static final int INT_LENGTH = 4;
	private static final int BUFFER_CACHE = 1024;// С
	private ServiceListener mListener;
	private SelectionKey key;
	private byte[] bytes;

	public Writer(ServiceListener mListener, SelectionKey key, byte[] bytes) {
		super();
		this.mListener = mListener;
		this.key = key;
		this.bytes = bytes;
	}

	@Override
	public void run() {
		Thread.currentThread().setName("Thread-Writer");
		SocketChannel sc = (SocketChannel) key.channel();
		ByteBuffer buffer = ByteBuffer.allocate(BUFFER_CACHE);
		try {
			if (sc.isConnected()) { // ӳɹѭϢ
				int length = bytes.length; // Ҫݵĳȣȴڻͷֶη
				int start = 0; // ֶʼ
				while (length > 0) {
					int part = 0; // ÿδС
					if (length >= (BUFFER_CACHE - INT_LENGTH)) {
						part = (BUFFER_CACHE - INT_LENGTH);
					} else {
						part = length % (BUFFER_CACHE - INT_LENGTH); // һδС
					}
					byte[] b = new byte[part]; // ֶ

					System.arraycopy(bytes, start, b, 0, part);// Ʒֶ
					// д
					buffer.clear(); // 
					if (start == 0) {
						buffer.putInt(length); // һηֶͷдݳ
					}
					buffer.put(b);// ַֽд뻺
					buffer.flip();// ûlimit
					while (buffer.hasRemaining()) {
						sc.write(buffer); // дƵ
					}
					start += part;
					length -= part;
				}
			}
		} catch (Exception e) {
			if (mListener != null) {
				mListener.onConnectInterrupt(key);
			}
		}

	}

}
